/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j;
	unsigned char	y, cb, cr;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(j = 0; j < 720; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			if (j >= 232 && j < 488 && i >= 16 && i < 120)  {
				y = 28;
				cr = 120;
				cb = 212;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				y = 180;
				cr = 128;
				cb = 128;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
		for(i = 0; i < 136; i++)  {
			y = 168;
			cr = 136;
			cb = 44;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			if (j >= 232 && j < 488 && i >= 16 && i < 120)  {
				y = 63;
				cr = 204;
				cb = 193;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				y = 145;
				cr = 44;
				cb = 147;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
		for(i = 0; i < 136; i++)  {
			y = 133;
			cr = 52;
			cb = 63;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			if (j >= 232 && j < 488 && i >= 16 && i < 120)  {
				y = 145;
				cr = 44;
				cb = 147;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				y = 63;
				cr = 204;
				cb = 193;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
		for(i = 0; i < 136; i++)  {
			y = 51;
			cr = 212;
			cb = 109;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			if (j >= 232 && j < 488 && i >= 16 && i < 120)  {
				y = 180;
				cr = 128;
				cb = 128;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
			else  {
				y = 28;
				cr = 120;
				cb = 212;
				fwrite(&cb, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
				fwrite(&cr, 1, 1, fpout);
				fwrite(&y, 1, 1, fpout);
			}
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 96; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 28;
			cr = 120;
			cb = 212;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 63;
			cr = 204;
			cb = 193;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 145;
			cr = 44;
			cb = 147;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 180;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	for(j = 0; j < 264; j++)  {
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < (136 * 2); i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 7;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 136; i++)  {
			y = 25;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < (136 * 2); i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 4; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	fclose(fpout);
	return 0;
}
