/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

unsigned	char	buffer422[1920 * 1088 * 2];

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j, index = 0;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(j = 0; j < 1080; j++)  {
		for(i = 0; i < 960; i++)  {
                        buffer422[index++] = 0x80;
            	        buffer422[index++] = 16;
                        buffer422[index++] = 0x80;
            	        buffer422[index++] = 235;
		}
	}
	fwrite(&buffer422[0], 1, 1920 * 1080 * 2, fpout);
	fclose(fpout);
	return 0;
}
