/*
MPEG 2 decoder bitstream xfer
*/

#include <stdio.h>
#include <stdlib.h>

#define	TRUE		1
#define	FALSE		0

int main(int argc, char **argv)
{
	FILE	*fpout;
	unsigned int	i, j;
	unsigned char	y, cb, cr;

	if (argc != 2) {
		fprintf(stderr, "usage: pat<outfile>\n");
		exit(-1);
	}

	/*--- open binary file (for parsing) ---*/
	fpout = fopen(argv[1], "wb");
	if (fpout == 0) {
		fprintf(stderr, "Cannot open output file <%s>\n", argv[1]);
		exit(-1);
	}

	for(j = 0; j < 1080; j++)  {
		for(i = 0; i < 2; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 16;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 38;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 60;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 82;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 104;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 126;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 147;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 169;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 191;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 213;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 87; i++)  {
			y = 235;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
		for(i = 0; i < 1; i++)  {
			y = 235;
			cr = 128;
			cb = 128;
			fwrite(&cb, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
			fwrite(&cr, 1, 1, fpout);
			fwrite(&y, 1, 1, fpout);
		}
	}
	fclose(fpout);
	return 0;
}
